#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <dlfcn.h>
/*
 * Copyright (C) 2016 ARM Limited. All rights reserved.
 * 
 * Copyright (C) 2008 The Android Open Source Project
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* IP block capability masks */
#define MALI_GRALLOC_FORMAT_CAPABILITY_OPTIONS_PRESENT            ((uint64_t) (1 << 0))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_BASIC                 ((uint64_t) (1 << 1))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_SPLITBLK              ((uint64_t) (1 << 2))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_WIDEBLK               ((uint64_t) (1 << 3))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_WIDEBLK_YUV_DISABLE   ((uint64_t) (1 << 4))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_YUV_NOREAD            ((uint64_t) (1 << 5))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_YUV_NOWRITE           ((uint64_t) (1 << 6))
#define MALI_GRALLOC_FORMAT_CAPABILITY_AFBC_TILED_HEADERS         ((uint64_t) (1 << 7))

int main(int argc, char *argv) {
	void *handle = dlopen("libGLES_mali.so", RTLD_LAZY);

	if (!handle) {
		fprintf(stderr, "Couldn't find Android DDK?");
		return 1;
	}

        void *sym = dlsym(handle, "mali_gralloc_format_capabilities");
	uint64_t caps;

	if(!sym) {
		fprintf(stderr, "Couldn't find symbol - is this an Android DDK?");
		return 1;
	}

	memcpy(&caps, sym, sizeof(caps));
	printf("Caps %llx\n", caps);
	dlclose(handle);
	return 0;
}

